#pragma once

#include <glm/vec2.hpp>

namespace WallpaperEngine::Input {
/**
 * Handles mouse input for the background
 */
class CMouseInput {
  public:
    virtual ~CMouseInput () = default;
    /**
     * Takes current mouse position and updates it
     */
    virtual void update () = 0;

    /**
     * The virtual pointer's position
     */
    [[nodiscard]] virtual glm::dvec2 position () const = 0;
};
} // namespace WallpaperEngine::Input
